from OpenGL.GL import *
import gutil
import os
import pygame
from Image import Image

class Animation:
    def __init__(self, tex_list, rate=1000, key=False):

        #rate is change frequency
        self.rate = rate
        self.image_list = []
        for x in tex_list:
            self.image_list.append(Image(x))
        self.start_time = pygame.time.get_ticks()

    def draw(self, pos=None, width = None, height = None, color=(1,1,1,1), rotation=0, rotationCenter=None, centered=0):

        delta = (int(pygame.time.get_ticks() - self.start_time)/self.rate)%len(self.image_list)

        glPushMatrix()
        glColor4fv(color)

        if pos:
            glTranslate(pos[0],pos[1],0)
            
        if centered:
            glTranslate(-self.image_list[delta].width/2,-self.image_list[delta].height/2,0)

        if rotation != 0:
                if rotationCenter == None:
                    rotationCenter = (self.self.image_list[delta] / 2, self.image_list[delta].height / 2)
                (w,h) = rotationCenter
                glTranslate(rotationCenter[0],rotationCenter[1],0)
                glRotate(rotation,0,0,-1)
                glTranslate(-rotationCenter[0],-rotationCenter[1],0)

        if width or height:
            if not width:
                width = self.image_list[delta].width
            elif not height:
                height = self.image_list[delta].height

            glScalef(width/(self.image_list[delta].width*1.0), height/(self.image_list[delta].height*1.0), 1.0)
                

        glCallList(self.image_list[delta].displayList)
        glPopMatrix()
