import gutil
import pygame
import Timer

from math import *
from pygame.locals import *
from OpenGL.GL import *
from random import *

from Text import Text
from PathFinder import *
from Timer import *

class ComputerOpponent:

    def __init__(self, cart, map):
        
        self.map = map
        self.cart = cart
        
        self.sp = self.map.mapData.shortestPath
        
        self.updates = 0
         
        self.i = 0
        self.step = 0
        self.peekTimer = 5
        self.peek = self.peekTimer
        
        self.N  = 1
        self.NE = 2
        self.E  = 3
        self.SE = 4
        self.S  = 5
        self.SW = 6
        self.W  = 7
        self.NW = 8
        
        self.speed = 0
        
        self.FASTER = 1
        self.SLOWER = 2
        self.REALLY_SLOW = 5
        
        self.state = None
        self.state_changed = True
        
        self.timer = ResettableTimer(50000, self.figureOutWhereWeAre, inc=.25, update=self.figureOutWhereWeAre)
        
        self.MOVE_FASTER    = 0
        self.MOVING_FASTER  = 1
        self.BREAK          = 5
        self.BREAKING       = 6
        self.TURN_RIGHT     = 10
        self.TURNING_RIGHT  = 11
        self.TURN_LEFT      = 15
        self.TURNING_LEFT   = 16
        self.NO_TURN = 0
        
        self.MAXIMUM_SPEED = 20
        self.SPEED_FAST = 15#7#15
        self.SPEED_MEDIUM = 4#10
        self.SPEED_SLOWER = 2#6
        self.SPEED_SLOWEST = 1#3
        self.targetSpeed = self.SPEED_FAST
        
        self.targetRotation = -90
        
        self.turning = self.NO_TURN
        
        #print "PATH LENGTH = ", len(self.sp)

        self.timer.start()
        
    def update(self):    
        
        if (self.sp):
            self.i += 1
            
            if (self.i > 1):
                self.i = 0
                (x,y) = self.sp[self.step]
                                
                oldX = self.cart.x
                oldY = self.cart.y
                
                dx = oldX - x
                dy = oldY - y
                
                dir = self.map.mapData.pathDirections[self.step]
                (nx,ny) = self.map.mapData.nicePath[self.step]
                   
                self.peek += 1
                if (self.peek >= self.peekTimer):
                    self.peek = 0
                    self.peekAtPath()
                
                if (self.speed < self.targetSpeed):
                    self.state = self.MOVE_FASTER
                    
                elif (self.speed > self.targetSpeed):
                    self.state = self.BREAK
                
                delta = self.cart.rotation - self.targetRotation
                if (-5 < delta < 5):
                    self.turning = self.NO_TURN
                    
                elif (self.cart.rotation > self.targetRotation):
                    self.turning = self.TURN_RIGHT
                    
                else:
                    self.turning = self.TURN_LEFT
                    
                #print "Current speed is ", self.speed, " and target speed is ", self.targetSpeed
                #print "Current rotation is ", self.cart.rotation, ' target is ', self.targetRotation
                """
                if (self.state == self.MOVE_FASTER):
                    self.cart.throttle = 'f'
                
                elif (self.state == self.BREAK):
                    self.cart.throttle = 'r'
                
                if (self.turning == self.TURN_LEFT):
                    self.cart.wheels = 'l'
                
                elif (self.turning == self.TURN_RIGHT):
                    self.cart.wheels = 'r'
                
                elif (self.turning == self.NO_TURN):
                    self.cart.wheels = 's'
                    
                """
                """
                else:
                    if (self.state == self.TURNING_LEFT and self.player.wheels == 'l'):
                        self.player.wheels = 's'
                    
                    elif (self.state == self.TURNING_RIGHT and self.player.wheels == 'r'):
                        self.player.wheels = 's'
                        
                    elif (self.state == self.MOVING_FASTER and self.player.throttle == 'f'):
                        self.player.throttle = 'n'
                        
                    elif (self.state == self.BREAKING and self.player.throttle == 'r'):
                        self.player.throttle = 'n'
                """
                #self.figureOutWhereWeAre()
                
                """
                if (dx < 0):
                    if (dy < 0):
                        self.cart.wheels = 'l'
                    else:
                        self.cart.wheels = 'r'
                elif (dx > 0):
                    if (dy < 0):
                        self.cart.wheels = 'r'
                    else:
                        self.cart.wheels = 'l'
                else:
                    self.cart.wheels = 'n'
                        
                """
                
                
                self.step += 4 - randint(1,3) 
                
                #if (self.step >= len(self.sp)):
                #    self.step = 0
                
                if (self.step >= len(self.sp)):
                    self.step -= len(self.sp)
                    self.step -= 1
                    
                (nx,ny) = self.map.mapData.nicePath[self.step]

                dir = self.map.mapData.pathDirections[self.step]

                rot = -90
                if (dir == self.N):
                    rot = -90
                elif (dir == self.NE):
                    rot = -135
                elif (dir == self.E):
                    rot = -180
                elif (dir == self.SE):
                    rot = -225
                elif (dir == self.S):
                    rot = -270
                elif (dir == self.SW):
                    rot = -315
                elif (dir == self.W):
                    rot = 0
                elif (dir == self.NW):
                    rot = -45
                
                self.cart.rotation = rot
                
                x = float(nx) * self.map.scale
                y = float(ny) * self.map.scale 
        
                self.cart.move((x,y))
                
    
    def figureOutWhereWeAre(self, e=None):
    
        cx = int(self.cart.x / self.map.scale)
        cy = int(self.cart.y / self.map.scale)
        
        bestMatch = 0
        min = 5000000

        curr = self.step
        
        for i in range(len(self.sp)):
            
            index = self.step + i
            if (index >= len(self.sp)):
                index -= len(self.sp)
                index -= 1
                
            (nx, ny) = self.sp[index]
            
            dx = cx-nx
            dy = cy-ny
            
            distance = dx*dx + dy*dy
            
            if (distance < min):
                min = distance
                bestMatch = index
            
            
        self.step = bestMatch    
        
        wrap = 0
        if (bestMatch < curr):
            wrap = len(self.sp)
            
        self.speed = bestMatch - curr + wrap

    def peekAtPath(self):
                

        stepValue = 25
        
        # Current location
        cx = int(self.cart.x / self.map.scale)
        cy = int(self.cart.y / self.map.scale)

        index = self.step + stepValue  #TODO
        if (index >= len(self.sp)):
            index = 0
            
        (nx,ny) = self.sp[index]
        
        dx = cx - nx
        dy = cy - ny
        
        dx = dx*dx*dx
        dy = dy*dy*dy
        
        div = float(stepValue * stepValue * stepValue)
        
        rotX = float(dx)/div * 90.0 * -1
        rotY = float(dy)/div * 90.0 * -1
        
        dx = nx - cx
        dy = ny - cy
        
        rot = rotY
        
        a = sqrt(dx*dx + dy*dy)
        b = dx
        angle = acos(dx/a)
        angle = angle*180/pi - 20
        
        if (dy < 0):
            angle *= -1
                  
        rot = angle
        
        if (rot > 10):
            self.targetSpeed = 1
        """
        if (dx < 0):
            if (dy < 0):
                dir = self.SE
                #rot = (rotY - 45) 
                print "SE"
            elif (dy == 0):
                dir = self.S
                #rot = rotY * -1
                print "S"
            else:
                dir = self.SW
                #rot = (rotY - 45) 
                print "SW"
        elif (dx > 0):
            if (dy < 0):
                dir = self.NE
                #rot = (rotY - 45)
                print "NE"
            elif (dy == 0):
                dir = self.N
                #rot = rotY
                print "N"
            else:
                dir = self.NW
                #rot = (rotY - 45)
                print "NW"
        else:
            if (dy < 0):
                dir = self.E
                #rot = rotX
                print "E"
            elif (dy > 0):
                dir = self.W
                #rot = rotX * -1
                print "W"
        """
        #if (rot < 8):
         #   rot = 0
            
        if (rot > 0):
            self.turning == self.TURN_LEFT
        else:
            self.turning == self.TURN_RIGHT
            
        self.targetRotation = self.cart.rotation + rot
        
        #print self.cart.rotation, ",", self.targetRotation, ",", rot,", dx=",dx,",dy=",dy
            
        """
        if (dir in (self.SE, self.SW, self.NW, self.NE)):
            dx1 = 0
            dx2 = 0
            dy1 = 0
            dy2 = 0
            
        
        elif (dir == self.E):
            tempx1 = dx1
            tempx2 = dx2
            dx1 = dy2
            dy1 = tempx1
            dy2 = tempx2

        elif (dir == self.W):
            tempx1 = dx2
            tempx2 = dx1
            dx1 = dy1
            dy1 = tempx1
            dy2 = tempx2
            
        elif (dir == self.S):
            tempx1 = dy1
            dx1 = dx2
            dy1 = dy2
            dy2 = tempx1
            
        
        factor = float(self.speed+1) / float(self.MAXIMUM_SPEED)
        peekAhead = int(100.0 * factor)
        
        turnThreshold = int(35.0 * factor)
        sharpTurn = int(50.0 * factor)
        straightRoad = int(90 * factor)

        (cx, cy) = self.sp[self.step]
        nextPoint = self.step + 1
        if (nextPoint >= len(self.sp)):
            nextPoint = 0
        (nx, ny) = self.sp[nextPoint]

        dx = cx - nx
        dy = cy - ny
        
        minX = cx
        maxX = cx
        minY = cy
        maxY = cy
        
        for i in range(peekAhead):
            index = i + self.step
            if (index >= len(self.sp)):
                index -= len(self.sp)
                index -= 1
            
            (nx,ny) = self.sp[index]
            
            if (nx > maxX):
                maxX = nx
            elif (nx < minX):
                minX = nx
                
            if (ny > maxY):
                maxY = ny
            elif (ny < minY):
                minY = ny
                

        
        dx1 = maxX - cx
        dx2 = cx - minX
        
        dy1 = maxY - cy
        dy2 = cy - minY
        
        dir = self.map.mapData.pathDirections[self.step]

        if (dir in (self.SE, self.SW, self.NW, self.NE)):
            dx1 = 0
            dx2 = 0
            dy1 = 0
            dy2 = 0
            
        elif (dir == self.E):
            tempx1 = dx1
            tempx2 = dx2
            dx1 = dy2
            dy1 = tempx1
            dy2 = tempx2

        elif (dir == self.W):
            tempx1 = dx2
            tempx2 = dx1
            dx1 = dy1
            dy1 = tempx1
            dy2 = tempx2
            
        elif (dir == self.S):
            tempx1 = dy1
            dx1 = dx2
            dy1 = dy2
            dy2 = tempx1
                
        if (dx1 > straightRoad):
            print "STRAIGHT STRETCH...GUN IT!"
            self.speed = self.FASTER
            self.state = self.MOVE_FASTER
            self.targetSpeed = self.SPEED_FAST

        if (dy1 > turnThreshold):
            if (dy2 > turnThreshold):
                print "WINDEY ROAD COMING UP!"
                self.speed = self.SLOWER
                self.state = self.BREAK
                self.targetSpeed = self.SPEED_MEDIUM
            else:   
                if (dy1 > sharpTurn):
                    print "SHARP LEFT TURN COMING UP!"
                    #self.targetRotation = self.cart.rotation + 80                
                    self.targetSpeed = self.SPEED_SLOWER
                else:
                    print "LEFT TURN COMING UP!"
                    #self.targetRotation = self.cart.rotation + 25                
                    self.targetSpeed = self.SPEED_SLOWER
                    
            self.state_changed = True
        elif (dy2 > turnThreshold):
            if (dy2 > sharpTurn):
                print "SHARP RIGHT TURN COMING UP!"
                #self.targetRotation = self.cart.rotation - 80                
                self.targetSpeed = self.SPEED_SLOWER
                
            else:
                print "RIGHT TURN COMING UP!"              
                #self.targetRotation = self.cart.rotation - 25
                self.targetSpeed = self.SPEED_SLOWER
            self.state_changed = True
    """
