from OpenGL.GL import *
import gutil
from random import *
from Image import Image

global steamImage
steamImage = None
class EffectSteam:
    def __init__(self, d=(0,0,0), v=(0,0,0), a=(0,0,0), color=(1,1,1,1), density=10, spread_d=60, spread_v=200, spread_a=20, fade=80):
        global steamImage
        self.list = []
        self.identity = (d,v,a)
        self.ttl = 100
        self.original_ttl = self.ttl*1.3
        self.color = color
        self.fade = fade
        if not steamImage:
            steamImage = Image("steam")
        self.cow = steamImage
        self.rot = 0
        
        for item in range(density):
            x = d[0] + (random()-.5)*spread_d
            y = d[1] + (random()-.5)*spread_d
            z = d[2] + (random()-.5)*spread_d
            
            my_d = (x, y, z)
                        
            x = v[0] + (random()-.5)*spread_v
            y = v[1] + (random()-.5)*spread_v
            z = v[2] + (random()-.5)*spread_v
            
            my_v = (x, y, z)
                    
            x = a[0] + (random()-.5)*spread_a
            y = a[1] + (random()-.5)*spread_a
            z = a[2] + (random()-.5)*spread_a
            
            my_a = (x, y, z)
            
            self.list.append((my_d, my_v, my_a))

            
    def update(self, delta, rot=0):
        #r, g, b, a = self.color
        self.rot = rot
        self.ttl -= delta * self.fade
        if self.ttl <= 0:
            return 0   
        
        for item in self.list:
            d, v, a = item
            
            delta = 100
            xa, ya, za = a
            xv, yv, zv = v
            xd, yd, zd = d
            
            xv += xa*delta
            yv += ya*delta
            zv += za*delta
            v = (xv, yv, zv)
            
            xd += xv*delta
            yd += yv*delta
            zd += zv*delta
            d = (xd, yd, zd)

            item = (d, v, a)
        
        return 1
            
    def draw(self):
        glPushMatrix()
        
        color = (1,1,1,self.ttl/(self.original_ttl+0.0))
        for item in self.list:
            d, v, a = item
            self.cow.drawIso(pos=(d[0],d[1]), z=d[2], mapRotation=self.rot, color = color)

        glPopMatrix()