from OpenGL.GL import *
from OpenGL.GLU import *

from Image import Image
from Text import Text

white=(255,255,255,255)

class HUD:
    def __init__(self, w, h, player, minimap):
        """code goes here"""
        self.player = player
        self.w = w
        self.h = h
        
        self.fire = player.fire
        self.steam = player.steam
        self.fireText = Text("Fire:", color=white, fontsize=30)
        self.fireNum = Text("%5d" % self.player.fire, color=white, fontsize=30)
        self.steamText = Text("Pressure:", color=white, fontsize=30)
        self.steamNum = Text("%5d" % self.player.steam, color=white, fontsize=30)
        self.minimap = minimap
        self.carts = None
        self.pinger = Image("ping")
        self.mini_scale = 3*self.h / self.minimap.height
        self.mini_x = w - self.minimap.width/self.mini_scale
        self.mini_y = 0
        
    def draw(self):
        glMatrixMode(GL_PROJECTION)
        glPopMatrix()
        glPushMatrix()
        #glLoadIdentity()
        gluOrtho2D(0, self.w, 0, self.h)
        glMatrixMode(GL_MODELVIEW)
    
        glDisable(GL_DEPTH_TEST)
        glLoadIdentity()
        
        #draw the minimap
        self.minimap.draw(pos = (self.mini_x, self.mini_y), width=self.minimap.width/self.mini_scale, height=self.minimap.height/self.mini_scale)
        #draw any carts on it
        if self.carts:
            for i in self.carts:
                pos, cart_color = i
                x, y = pos
                self.pinger.draw(pos=(x/self.mini_scale+self.mini_x,y/self.mini_scale+self.mini_y), centered=1, color=cart_color)
        """self.fireText.draw(pos=(5,5))
        self.fireNum.draw(pos=(10+self.fireText.width, 5))
        self.steamText.draw(pos=(400, 5))
        self.steamNum.draw(pos=(410+self.steamText.width, 5))"""
    
    def update(self, carts=None):
        """if self.fire != self.player.fire:
            self.fire = self.player.fire
            self.fireNum = Text("%5d" % self.player.fire, color=white, fontsize=30)
        if self.steam != self.player.steam:
            self.steam = self.player.steam
            self.steamNum = Text("%5d" % self.player.steam, color=white, fontsize=30)"""
        if carts:
            self.carts = []
            for i in carts:
                self.carts.append(i)
        