import sys
import gutil
import pygame
from pygame.locals import *
from OpenGL.GL import *
from Text import Text
from Image import Image
from OpenGL.GLU import *

#Makes a pretty screen and intro
class MainMenu:

    # ttl   = seconds before returning if no key is pressed. -1 is infinate
    # file  = file to read from
    # speed = credits per minute to scroll through
    def __init__(self, screen, ttl=50.0):
        self.w = screen[0]
        self.h = screen[1]
        self.ttl = ttl
        black = (255,255,255,255)
        self.background = Image("background2")
        self.corner = Text("Esc to exit.   ",color=(0,0,0,255),fontsize = 40)
        #self.title = Text("Put Nice Logo Here.",color=(0,0,0,255),fontsize = 50)
        self.options = []
#        self.options.append((((1,0,0), 0), Text("Splash Screen", color=black,fontsize = 30)))
#        self.options.append((((1,1,0), 0), Text("Main Menu (you're already here)", color=black,fontsize = 30)))

        self.options.append((((1,4,0), 6), Text("Time Trials", color=black,fontsize = 30)))
        self.options.append((((1,4,0), 8), Text("One Player - Vs Computer (really bad!)", color=black,fontsize = 30)))
        self.options.append((((1,4,0), 2), Text("Two Player - Head To Head", color=black,fontsize = 30)))

        self.options.append((((1,3,0), 0), Text("Credits", color=black,fontsize = 30)))
#        self.options.append((((1,2,0), 0), Text("Options", color=black,fontsize = 30)))
        self.options.append((((1,-1,0), 0), Text("Quit", color=black,fontsize = 30)))
        self.position = 0
        
        
    #draws the list to the screen on a vertical offset   
    def draw(self, pos=(0,300), color=(1,1,1,1), screen_width=800):
        glDisable(GL_DEPTH_TEST)
        glMatrixMode(GL_PROJECTION)
        glPushMatrix()
        glLoadIdentity()
        gluOrtho2D(0, self.w, 0, self.h)
        glMatrixMode(GL_MODELVIEW)
        glPushMatrix()
        glColor4fv(color)
        y = self.h - 200 #-self.title.height
        
        #self.text.draw(pos)
        self.background.draw(width = self.w, height = self.h)
        self.corner.draw(pos = (self.w-self.corner.width, 20))
        #self.title.draw(pos = (0,y))
        #y -= self.title.height*2
        
        for i in range(len(self.options)):
            x, item = self.options[i]
            y -= item.height
            menu_color = (1,1,1,1)
            if i == self.position:
                menu_color = (.8,.8,.8,.9)
            item.draw(pos = (100, y), color = menu_color)
            

        glPopMatrix()
        glMatrixMode(GL_PROJECTION)
        glPopMatrix()
        glMatrixMode(GL_MODELVIEW)
        glEnable(GL_DEPTH_TEST)
        
    def handleKey(self, type, key):
        if type == KEYDOWN:
            if key == K_ESCAPE:
                return ((1,-1,0), 0)
            elif key == K_UP:
                self.position -= 1
                if self.position < 0:
                    self.position = len(self.options) - 1
            elif key == K_DOWN:
                self.position += 1
                if self.position > len(self.options) - 1:
                    self.position = 0
                    
            elif key == K_SPACE or key == K_RETURN:
                x, y = self.options[self.position]
                return x
                

        return ((0,0,0), 0)
                