import sys
import gutil
import pygame
from pygame.locals import *
from OpenGL.GL import *
from Text import Text
from Image import Image
from OpenGL.GLU import *

class MapSelect:

    def __init__(self, screen):
        self.w = screen[0]
        self.h = screen[1]

        black = (255,255,255,255)
        self.background = Image("Racer1")
        self.corner = Text("Esc to return to main menu.   ",color=(0,0,0,255),fontsize = 40)
        self.title = Text("Pick Your Track",color=(0,0,0,255),fontsize = 50)
        self.options = []
        self.options.append(("track1", Text("Oval Of Dooom", color=black,fontsize = 30)))
        self.options.append(("TrackSplit", Text("Split Decision", color=black,fontsize = 30)))
        self.options.append(("track3", Text("Par For The Course", color=black,fontsize = 30)))
        self.options.append(("trackhazard1", Text("Banks A Hoy", color=black,fontsize = 30)))
        self.options.append(("trackpinball", Text("Pinball Wizard", color=black,fontsize = 30)))
        self.options.append(("TrackWideThin", Text("Wide Thin", color=black,fontsize = 30)))
        self.options.append(("trackpacman", Text("PacMan", color=black,fontsize = 30)))
        self.options.append(("trackwhynot", Text("Why Not?", color=black,fontsize = 30)))
        self.options.append(("tracktooth", Text("Dentists Run", color=black,fontsize = 30)))
        self.options.append(("trackfish", Text("Here Guppy Guppy", color=black,fontsize = 30)))
        self.options.append(("tracktriforce", Text("It's A Triangle", color=black,fontsize = 30)))
        self.position = 0
        
        
    #draws the list to the screen on a vertical offset   
    def draw(self, pos=(0,300), color=(1,1,1,1), screen_width=800):
        glDisable(GL_DEPTH_TEST)
        glMatrixMode(GL_PROJECTION)
        glPushMatrix()
        glLoadIdentity()
        gluOrtho2D(0, self.w, 0, self.h)
        glMatrixMode(GL_MODELVIEW)
        glPushMatrix()
        glColor4fv(color)
        y = self.h-self.title.height

        #self.text.draw(pos)
        self.background.draw(width = self.w, height = self.h)
        self.corner.draw(pos = (self.w-self.corner.width, 20))
        self.title.draw(pos = (0,y))
        y -= self.title.height*2
        
        for i in range(len(self.options)):
            x, item = self.options[i]
            y -= item.height
            menu_color = (0,0,0,1)
            if i == self.position:
                menu_color = (0,0,1,1)
            item.draw(pos = (20, y), color = menu_color)

        glPopMatrix()
        glMatrixMode(GL_PROJECTION)
        glPopMatrix()
        glMatrixMode(GL_MODELVIEW)
        glEnable(GL_DEPTH_TEST)
        
    def handleKey(self, type, key):
        if type == KEYDOWN:
            if key == K_ESCAPE:
                return (1,1,0, "none")
            elif key == K_UP:
                self.position -= 1
                if self.position < 0:
                    self.position = len(self.options) - 1
            elif key == K_DOWN:
                self.position += 1
                if self.position > len(self.options) - 1:
                    self.position = 0
            elif key == K_SPACE or key == K_RETURN:
                track, x = self.options[self.position]
                return (1,4,2, track)



        return (0,0,0, "none")
                