import sys
import gutil
import pygame
from pygame.locals import *
from OpenGL.GL import *
from Text import Text
from Image import Image
from OpenGL.GLU import *

#Makes a pretty screen and intro
class Options:

    # ttl   = seconds before returning if no key is pressed. -1 is infinate
    # file  = file to read from
    # speed = credits per minute to scroll through
    def __init__(self, screen, ttl=50.0):
        self.w = screen[0]
        self.h = screen[1]
        self.ttl = ttl
        self.background = Image("Roller1Render2")
        self.text = Text("Check back later...",color=(0,0,0,255))
        
        
    #draws the list to the screen on a vertical offset   
    def draw(self, pos=(0,300), color=(1,1,1,1), screen_width=800):
        glDisable(GL_DEPTH_TEST)
        glMatrixMode(GL_PROJECTION)
        glPushMatrix()
        glLoadIdentity()
        gluOrtho2D(0, self.w, 0, self.h)
        glMatrixMode(GL_MODELVIEW)
        glPushMatrix()
        glColor4fv(color)

        self.background.draw(width = self.w, height = self.h)
        self.text.draw(pos = (self.w-self.text.width, 20))

        glPopMatrix()
        glMatrixMode(GL_PROJECTION)
        glPopMatrix()
        glMatrixMode(GL_MODELVIEW)
        glEnable(GL_DEPTH_TEST)
        
    #updates the current delta
    def update(self, dt):
        self.ttl -= dt
        
    def handleKey(self, type, key):
        if type == KEYDOWN:
            if key == K_ESCAPE:
                return (1,1,0)
            elif key == K_SPACE:
                return (1,1,0)
        return (0,0,0)
