import gutil
import os
import pygame
import sys

from pygame.locals import *
from PriorityDictionary import *

from Image import Image
from Text import Text

class PathFinder:

    def __init__(self, G):
        
        # define some directions
        self.N  = 1
        self.NE = 2
        self.E  = 3
        self.SE = 4
        self.S  = 5
        self.SW = 6
        self.W  = 7
        self.NW = 8
        
        self.G = G
        
        
    def Dijkstra(self, start, end=None):
        
        D = {}	# dictionary of final distances
        P = {}	# dictionary of predecessors
        Q = PriorityDictionary()   # est.dist. of non-final vert.
        Q[start] = 0
        
        for v in Q:
            D[v] = Q[v]
            if v == end: break
            
            for w in self.G[v]:
                vwLength = D[v] + self.G[v][w]
                if w in D:
                    if vwLength < D[w]:
                        raise ValueError, "Better path already found"
                elif w not in Q or vwLength < Q[w]:
                    Q[w] = vwLength
                    P[w] = v
        
        return (D,P)
  
    def shortestPath(self, sx, sy, fx, fy):
        
        print "Finding shortest path from ", (sx,sy), " to ", (fx, fy)
        D,P = self.Dijkstra((sx,sy),(fx, fy))
        Path = []
        #print P
        while 1:
            Path.append((fx, fy))
            if (fx, fy) == (sx,sy): break
            (fx, fy) = P[(fx, fy)]
        Path.reverse()
        return Path
 