import sys
import os
import gutil
import pygame
from pygame.locals import *
from OpenGL.GL import *
from Text import Text
from Image import Image
from OpenGL.GLU import *

#Makes a pretty screen and intro
class Splash:

    # ttl   = seconds before returning if no key is pressed. -1 is infinate
    # file  = file to read from
    # speed = credits per minute to scroll through
    def __init__(self, screen, ttl=10.0):
        self.w = screen[0]
        self.h = screen[1]
        self.ttl = ttl
        self.splash = Image("background3spacebar")
        pygame.mixer.music.load(os.path.join('data', "Jingles1.ogg"))
        pygame.mixer.music.play()
        
        
    #draws the list to the screen on a vertical offset   
    def draw(self, pos=(0,300), color=(1,1,1,1), screen_width=800):
        glDisable(GL_DEPTH_TEST)
        glMatrixMode(GL_PROJECTION)
        glPushMatrix()
        glLoadIdentity()
        gluOrtho2D(0, self.w, 0, self.h)
        glMatrixMode(GL_MODELVIEW)
        glPushMatrix()
        glColor4fv(color)

        #self.background.draw(width = self.w, height = self.h)
        #scale = (self.splash.width*1.6)/self.w
        #self.splash.draw(pos=(0,int(self.h-self.splash.height/scale)),width = int(self.splash.width/scale), height = int(self.splash.height/scale))
        self.splash.draw(width = self.w, height = self.h)

        glPopMatrix()
        glMatrixMode(GL_PROJECTION)
        glPopMatrix()
        glMatrixMode(GL_MODELVIEW)
        glEnable(GL_DEPTH_TEST)
        
        
    def handleKey(self, type, key):
        if type == KEYDOWN:
            if key == K_ESCAPE or key == K_SPACE or key == K_RETURN:
                return (1,1,0)
                pygame.mixer.music.fadeout(2)

        return (0,0,0)
