
def circleCollide(o1, o2):
    """"""
    dist = (((o1.x-o1.radius) - (o2.x-o2.radius)) ** 2 + ((o1.y-o1.radius) - (o2.y-o2.radius)) ** 2) ** 0.5
    if dist < (o1.radius + o2.radius):
        return True
    else:
        return False


def circleRespond(o1, o2):
    xv = (o1.xv * (o1.mass-o2.mass)+ 2 * (o2.mass * o2.xv)) / (o1.mass+o2.mass)
    yv = (o1.yv * (o1.mass-o2.mass)+ 2 * (o2.mass * o2.yv)) / (o1.mass+o2.mass)
    
    return xv,yv
    
    
def squareCollide(cart, sx, sy, sw, sh):
    sx -= cart.radius
    sy -= cart.radius
    sw += cart.radius
    sh += cart.radius

    if cart.x-cart.radius > sx and cart.x-cart.radius < sx + sw and cart.y-cart.radius > sy and cart.y-cart.radius < sy + sh:
        return True
    else:
        return False


def squareResponse(cart , sx, sy, sw, sh):
    sx -= cart.radius
    sy -= cart.radius
    sw += cart.radius
    sh += cart.radius
    
    if abs(cart.x-cart.radius - sx) > abs(cart.x-cart.radius - (sx + sw)):
        xd = abs(cart.x-cart.radius - sx)
    else:
        xd = abs(cart.x-cart.radius - (sx + sw))
        
    if abs(cart.y-cart.radius - sy) > abs(cart.y-cart.radius - (sy + sh)):
        yd = abs(cart.y-cart.radius - sy)
    else:
        yd = abs(cart.y-cart.radius - (sy + sh))
        
    if yd < xd:
        return -1.0, 1.0
    else:
        return 1.0, -1.0



def hasInteresect(A, B, C, D):
    #print "check"
    xa, ya = A
    xb, yb = B
    xc, yc = C
    xd, yd = D

    denom = (yb-ya+0.0)*(xc-xd)-(yd-yc)*(xa-xb)
    if denom == 0:
        return 0
    
    x = ((xa-xb+0.0)*(xd*yc-xc*yd)-(xc-xd)*(xb*ya-xa*yb)) / denom
    
    if xa > xb:
        if x < xa and x > xb:
            return 1
    else:
        if x < xb and x > xa:
            return 1
            
    return 0
